# coding: utf-8

"""
    Trinsic API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from trinsic_api.models.language import Language
from typing import Optional, Set
from typing_extensions import Self

class MobileIdInput(BaseModel):
    """
    MobileIdInput
    """ # noqa: E501
    mobile_id_phone_number: Optional[StrictStr] = Field(default=None, description="The user's phone number in E.164 format", alias="mobileIdPhoneNumber")
    mobile_id_national_identity_number: Optional[StrictStr] = Field(default=None, description="The user's National ID number", alias="mobileIdNationalIdentityNumber")
    mobile_id_language: Optional[Language] = Field(default=None, description="The user's language -- LIT, EST, ENG, or RUS", alias="mobileIdLanguage")
    __properties: ClassVar[List[str]] = ["mobileIdPhoneNumber", "mobileIdNationalIdentityNumber", "mobileIdLanguage"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MobileIdInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if mobile_id_phone_number (nullable) is None
        # and model_fields_set contains the field
        if self.mobile_id_phone_number is None and "mobile_id_phone_number" in self.model_fields_set:
            _dict['mobileIdPhoneNumber'] = None

        # set to None if mobile_id_national_identity_number (nullable) is None
        # and model_fields_set contains the field
        if self.mobile_id_national_identity_number is None and "mobile_id_national_identity_number" in self.model_fields_set:
            _dict['mobileIdNationalIdentityNumber'] = None

        # set to None if mobile_id_language (nullable) is None
        # and model_fields_set contains the field
        if self.mobile_id_language is None and "mobile_id_language" in self.model_fields_set:
            _dict['mobileIdLanguage'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MobileIdInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "mobileIdPhoneNumber": obj.get("mobileIdPhoneNumber"),
            "mobileIdNationalIdentityNumber": obj.get("mobileIdNationalIdentityNumber"),
            "mobileIdLanguage": obj.get("mobileIdLanguage")
        })
        return _obj


